	;; extern C function
	.globl	___main

	;; 
	.globl	_init_interrupts
	.globl	_vsync
	.globl	_init_sound_driver
	.globl	_set_voice

VOICE16	equ	(1<<31)
	;;

	.text	
	.globl	_main

	.68000
_main:
	;; finish init (random seed, malloc, ...)
	jsr	___main
	;; init interrupts (VBL queue)
	jsr	_init_interrupts
	;; init sound driver
	move.l	#18000,-(sp)
	jsr	_init_sound_driver
	addq.w	#4,sp
	move.l	d0,realfreq
	;;
	;; set repeat sample
	move.l	#snd_end-snd_start,-(sp)
	move.l	#snd_start,-(sp)
	;; set initial sample
	move.l	#snd_end-snd_start,-(sp)
	move.l	#snd_start,-(sp)
	;; set sample characteristics (not optimized)
	move.l	#VOICE16,d1	; 16 bits
	moveq	#8,d2		; panning = 8
	swap	d2
	lsl.l	#8,d2		
	or.l	d2,d1		; add panning
	moveq	#64,d2		; volume = 64
	swap	d2		
	or.l	d2,d1		; add volume
	move.l	#16000,d2	; replay freq = 16000 Hz
	lsl.l	#8,d2
	lsl.l	#4,d2
	move.l	realfreq,d0
	divu.w	d0,d2		
	move.w	d2,d1		; add divisor
	move.l	d1,-(sp)
	;; voice 0
	move.l	#0,-(sp)
	jsr	_set_voice
	add.w	#24,sp
.loop:
	jsr	_vsync
	bra.s	.loop


	.bss
realfreq:	ds.l	1

	.data
	
	.even
snd_start:	
 	incbin	"ocean.raw"
snd_end:

	